/// Service implementing notification.

var NotificationService = {
	addDailyNotification : function(id, time, message) {
		this.removeNotification(id);

		// alert("added id:" + id + ":" + message);
		var notificationDate = Date.today();

		// add the specified time
		var parts = time.split(':');
		notificationDate.addHours(parts[0]);
		notificationDate.addMinutes(parts[1]);

		if (typeof plugins !== "undefined") {
			plugins.localNotification.add({
				date : notificationDate,
				message : message,
				repeatDaily : true,
				id : id
			});
		}

	},

	addSingleNotification : function(id, notificationDate, message) {
		this.removeNotification(id);

		if (typeof plugins !== "undefined") {
			plugins.localNotification.add({
				date : 
					notificationDate,
				message : message,
				repeatDaily : false,
				id : id
			});
		}
	},

	removeNotification : function(id) {
		if (typeof plugins !== "undefined") {
			plugins.localNotification.cancel(id);
		}
	},
	
	cancelAllNotifications : function() {
		if (typeof plugins !== "undefined") {
			plugins.localNotification.cancelAll();
		}
	}

};
