$(function () {
    var afteller = null;
    var ALARM_AFTELTIJD = 5; // seconden
    var alarmGestartOp = null;

    $("a[href=#alarmScherm]").click(function () {
    	navigationController.gotoPage("#alarmScherm", true);
        return false;
    });
    
    var updateNoContactsWarning = function () {
        //check of we belcontacten hebben ingesteld
        var hasBelContact = false;
        var contacten = contactenController.getAll();
        if (typeof contacten !== "undefined") {
            for (var i in contacten) {
                if (contacten[i].isQuickDial) {
                    hasBelContact = true;
                }
            }
        }
        if (!hasBelContact) {
            $("#alarmNoContactsWarning").show();
        } else {
            $("#alarmNoContactsWarning").hide();
        }


    };
    /*
    * Reset timer en zet de aftelTijd terug in de pagina zodat de volgende keer
    * als de pagina wordt geopend, de text niet verspringt
    */
    $("#alarmScherm").on("pagebeforeshow",
			function () {
			    $("#alarmTitel").show();
			    $("#alarmAfbrekenLink").show();

			    $("#alarmKnoppenGroep").hide().empty();
			    $("#alarmTekst").hide();
			    $("#alarmPlaatje").hide();
			    $("#alarmTimer").html(jQuery.i18n.prop('i18n_alarm_seconds', ALARM_AFTELTIJD));


			    var alarmFooter = [];
			    alarmFooter.push("<div id='alarmcontrolgroup' data-role='navbar' data-type='horizontal'>");
			    alarmFooter.push("<ul>");
			    var contacts = getJSON("epContact");
			    
                for (i in contacts) {
			        if (contacts[i].isQuickDial) {
			            alarmFooter.push("<li><a href='tel:" + contacts[i].phoneNumber + "'  data-icon='navbar-dial'>" + jQuery.i18n.prop('i18n_dial') + " "
								+ contacts[i].name + "</a></li>");
			        }
			    }
			    alarmFooter.push("<li><a href='#' data-role='button' id='alarmButtonStop' data-icon='navbar-alarm'>" + jQuery.i18n.prop("i18n_alarm_abort") + "</a></li>");
			    
                alarmFooter.push("</ul>");
			    alarmFooter.push("</div>");
			    $("#alarmKnoppenGroep").append(alarmFooter.join(""));


			    $("#alarmcontrolgroup").navbar();
			    updateNoContactsWarning();
			});

    /*
    * Wanneer er een transitie naar deze pagina wordt gemaakt, start dan het
    * alarm opnieuw.
    */
    $("#alarmScherm").on("pageshow", function () {
        afteller = startCountDown(ALARM_AFTELTIJD);
    });

    /*
    * Reset het alarm wanneer er wordt afgebroken voordat het alarm wordt
    * geactiveerd en breng de gebruiker terug naar de start pagina.
    */
    $("#alarmAfbrekenLink").click(function () {
        clearInterval(afteller);
        
        navigationController.gotoPage('#calendarWeekPage', true);
    });

    /**
    * Start de aftel counter op het alarmscherm
    */
    function startCountDown(seconds) {
        countDown = setInterval(function () {
            $("#alarmTimer").html(jQuery.i18n.prop('i18n_alarm_seconds', seconds));
            if (seconds <= 0) {
                // Klaar met aftellen, start het alarm
                clearInterval(countDown);
                $("#alarmTimer").html(jQuery.i18n.prop('i18n_alarm_seconds', seconds));
                                
                // increase omniture alarm count
                var omnitureArr = getJSON('epOmniture');
                var omnitureInfo = (omnitureArr == null ? new epOmniture() : omnitureArr[0]);
                omnitureInfo.alarmCount++;
                storeJSON(omnitureInfo, omnitureInfo.id);
                                
                if (window.plugins != undefined && window.plugins.Omniture != undefined) {
                    // alarm count
                    window.plugins.Omniture.trackAlarm(omnitureInfo.omnitureUdid);
                } else {
                    console.log("Could not track alarm count");
                }
                                
                activateAlarm();

            }
            seconds--;
        }, 1000);
        return countDown;
    }

    /**
    * Start de optel counter op het alarmscherm
    */
    function startCountUp(seconds) {
        countUp = setInterval(function () {
            var countDate = new Date(0, 0, 0, 0, 0, seconds);
            $("#alarmTimer").html(jQuery.i18n.prop('i18n_alarm_minutes_run', countDate.toString('HH:mm:ss')));
            seconds++;
        }, 1000);
        return countUp;
    }

    /**
    * Start de teller hoe lang het alarm al loopt en toon bio informatie en
    * quick dial knoppen.
    */
    function activateAlarm() {
        $("#alarmNoContactsWarning").hide();
        $("#alarmTitel").hide();
        $("#alarmAfbrekenLink").hide();

        $("#alarmPlaatje").show();
        $("#alarmTekst").text(getOrCreateBio().customAlarmMessage);
        $("#alarmTekst").show();
        $("#alarmKnoppenGroep").show();

        if (window.plugins != undefined && window.plugins.PowerManagement != undefined) {
            window.plugins.PowerManagement.acquire(function () {
                console.log('lock acquired');
            }, function () {
                console.log('no lock acquired');
            });
        } else {
            console.log('Cannot prevent screen from locking: no powermanagement available');
        }

        var countUp = startCountUp(0);
        var alarmGestartOp = new Date();

        // sendAlarmSms();

        /*
        * stop de teller en registreer automatisch een aanval ga daarna terug
        * naar het login scherm.
        */
        $("#alarmButtonStop").on("click", function () {
            clearInterval(countUp);
            $('.navitem a').parent().removeClass("navitem-active");

            var automatischeAanval = new epEventStroke(alarmGestartOp, 1);
            automatischeAanval.notes = jQuery.i18n.prop('i18n_alarm_automatic_note');
            automatischeAanval.duration = Math.ceil((new Date() - alarmGestartOp) / 1000 / 60);
            automatischeAanval.eindDateTime = new Date();
            automatischeAanval.strokeType = "";
            automatischeAanval.intensity = 1;
            automatischeAanval.strokeCount = 1;
            storeJSON(automatischeAanval);

            if (getSettings().askPin == false) {
            	navigationController.gotoPage("#calendarWeekPage", true);
            } else {
                window.location = "index.html";
            }

            if (window.plugins != undefined && window.plugins.PowerManagement != undefined) {
                window.plugins.PowerManagement.release();
            }
        });
    }

    /**
    * Sprint 1: default sms window openen met tekst erin zodat de gebruiker
    * alleen op send hoeft te drukken. Latere sprint: in de background sturen
    * van sms (telefoon specifiek).
    */
    // function sendAlarmSms(phoneNumber, message) {
    //
    // // Bio gegevens ophalen
    // var bio_array = getJSON('epBio');
    // var bio = bio_array[0];
    //
    // // Contacten ophalen
    // var contacts = getJSON('epContact');
    // if (contacts != null) {
    // var phoneNumbers = [];
    // for (i in contacts) {
    // var contact = contacts[i];
    // if (contact.isSmsContact) {
    // phoneNumbers.push(contact.phoneNumber, ';');
    // }
    // }
    // phoneNumbers.pop(); // verwijdert de laatste punt;komma
    //
    // var smsBody = [];
    // smsBody.push(jQuery.i18n.prop('i18n_alarm_sms_default_text', bio.name));
    //
    // // locatie van telefoon bepalen;
    // // dit moet via callback functies omdat dit asynchroon gebeurt.
    // var locationFound = function(loc) {
    // locatielink = "http://maps.google.com/?q=loc:" + loc.coords.latitude +
    // "," + loc.coords.longitude;
    // smsBody.push(" ", jQuery.i18n.prop('i18n_alarm_sms_location_text',
    // locatielink));
    // QuintorPhonegapPlugins.sendSms(phoneNumbers.join(''), smsBody.join(''));
    // };
    //
    // var locationNotFound = function() {
    // locatielink = jQuery.i18n.prop('i18n_no_location_information');
    // smsBody.push(" ", locatielink);
    // QuintorPhonegapPlugins.sendSms(phoneNumbers.join(''), smsBody.join(''));
    // };
    //
    // navigator.geolocation.getCurrentPosition(locationFound, locationNotFound,
    // {
    // maximumAge : 3000,
    // timeout : 5000,
    // enableHighAccuracy : true
    // });
    // }
    //
    // }
});
