/// <reference path="./libs/jquery.mobile/jquery-1.7.1-vsdoc.js" />
/// <reference path="datalayer.js" />
var EP_itemHeight = 40;
var EP_calendar_month_availableHeightPixels = 200;

var RED_DOT = "dot_red.png";
var GREEN_DOT = "dot_green.png";
var BLUE_DOT = "dot_blue.png";

/*
 * Navigatie naar de kalender pagina. De huidige week wordt gezet en de kalender
 * wordt opgebouwd.
 * 
 * Voordat de pagina laad, bouw opnieuw de calender op.
 */

$('#lvCalendarDayList li').live('tap', function(event) {

	// Navigeer naar edit pagina
	var eventDate = sessionStorageWrapper().GetSelectedDay();
	// Date.parse(window.sessionStorage.getItem('selected_day'));
	var eventId = $(this).attr('id');

	/*
	 * Er moet of een event bestaan, of een medicijn, of een behandelschema
	 * medicijnschema aan het id dat gekoppeld is aan het listitem.
	 */
	var event = getEventByDay(eventDate, eventId);
	var medicine = mijnMedicatieController.get(eventId);
	var medicijnschema = behandelschemaController.getMedicijnSchemaByServerId(eventId);
	if (event == null && medicine == null && medicijnschema == null) {
		return false;
	}

	// Bepaal welke edit pagina we moeten openen
	if (event != null && event.eventType.custom == true) {
		eigenGebeurtenisController.Edit(event);
	} else {
		var eventName = (event != null) ? event.eventType.name : "Medicijngebruik";

		if (eventName == "Aanval") {
			aanvalController.Edit(event);
		} else if (eventName.match("^algemeen_")) {
			algemeneGebeurtenisController.Edit(event);
		} else if (eventName == "IncidenteleMedicatie") {
			medicijnController.Edit(event);
		} else if (eventName == "Bijwerking") {
			bijwerkingenController.Edit(event);
		} else if (eventName == "AfwijkendMedicijngebruik") {
			afwijkendeMedicatieController.Edit(event);
		} else if (eventName == "Medicijngebruik") {
			if (medicine != null) {
				var daypart = $(this).attr('daypart');
				afwijkendeMedicatieController.New(medicine, daypart);
			} else if (medicijnschema != null) {
				var daypart_time = $(this).attr('time');
				afwijkendeMedicatieController.NewForBehandelSchema(medicijnschema, daypart_time);
			}
		}
	}

});

$('#calendarWeekPage').live('pageinit', function() {
	setWeek();
	setMonth();
});

/*
 * Als de kalender voor de eerste keer wordt geladen zet de week dan op de
 * huidige week.
 */
$('#calendarWeekPage').live('pagebeforeshow', function() {
	$('.calendarHeader').find('.ui-select').addClass('header-combobox');
	setSelectedCalendar('week');
	redrawCalendar();
});

$('#calendarWeekPage').live('pageshow', function() {
	/*
	 * Onderstaande opties zijn noodzakelijk om de waarde van de combobox weer op
	 * de goede te zetten als de pagina wordt geladen.
	 */
	$('#select-calendar-week > option[value="week"]').attr('selected', "");
	$('#select-calendar-week').selectmenu('refresh');
//	$('#newButton').addClass('ui-icon-grid').trigger('create');

});

/**
 * Renders the select/combobox in the calendar headerbar
 * 
 * @param selectedOption
 */
function renderCalendarSelect(selectedOption) {
	var $template = $('<div>');
	var $select = $('<select class="header-combobox select-calendar" data-theme="c" data-icon="grid" name="select-calendar" id="select-calendar-'
			+ selectedOption + '" tabindex="-1">');
	$select.append($('<option value="month" class="i18n_month"></option>'));
	$select.append($('<option value="week" class="i18n_week"></option>'));
	$select.append($('<option value="vandaag" class="i18n_today"></option>'));
	$select.find('option[value="' + selectedOption + '"]').attr('selected', "");
	$template.append($select);
	document.write($template.html());
}

/*
 * Als je op een optie klikt in de calender combobox
 */
$('#select-calendar-week,#select-calendar-month').live('change', function() {
	var option = $(this).find('option:selected').val();
	if (option == 'month') {
		navigationController.gotoPage("#calendarMonthPage");
	} else if (option == 'week') {
		navigationController.gotoPage("#calendarWeekPage");
	} else if (option == 'vandaag') {
		setWeek();
		setMonth();
		redrawCalendar();
		redrawMonthCalendar();
		var cal = getSelectedCalendar();
		$('#select-calendar-' + cal + ' > option[value="' + cal + '"]').attr('selected', "");
		$('#select-calendar-' + cal).selectmenu('refresh');
	}
});

/*
 * Swipe events voor de kalender.
 */
$('#calendarWeekPage').live('swipeleft swiperight', function(event) {
	if (event.type == "swipeleft") {
		setWeek('next');
		redrawCalendar();
	}

	if (event.type == "swiperight") {
		setWeek('previous');
		redrawCalendar();
	}
});

$('#calendarDayPage').live('swipeleft swiperight', function(event) {

	if (event.type == "swipeleft") {
		setDay('next');
		buildDayCalendar();
	}
	if (event.type == "swiperight") {
		setDay("previous");
		buildDayCalendar();
	}
});

$('#calendarMonthPage').live('swipeleft swiperight', function(event) {

	if (event.type == "swipeleft") {
		setMonth('next');
		redrawMonthCalendar();
	}

	if (event.type == "swiperight") {
		setMonth("previous");
		redrawMonthCalendar();
	}
});

/*
 * Klikken op een dag in de week kalender. Dag wordt uit de link gehaald en
 * opgeslagen in session storage en navigatie naar dagpagina.
 */
$('div[id="calendarWeekPage"] a[class="dayItemLink"]').live("click", function() {
	var date = new Date($(this).attr("date"));

	sessionStorageWrapper().SetSelectedDay(date);
	// sessionStorage.setItem('selected_day', date.toDateString());
	navigationController.gotoPage("#calendarDayPage");
});

/*
 * Toevoegen van een week kalender icon.
 */
function setWeekIcon(type, date, dayTemplateIconSpan) {
	// var this_date_span = '#dayItemGrid span[date="' + date.toDateString() +
	// '"]';
	var icon = $('<img>').addClass("calendarWeekIcon");

	var nr_of_icons = dayTemplateIconSpan.find('img').length;
	// dayTemplateIconSpan.find('img[src="img/dots.png"]').length;
	/*
	 * Blijf plaatjes toevoegen tot er 10 zijn Als er tien zijn kijken of het
	 * laatste plaatje de vorige iteratie al is vervangen,
	 */
	if (nr_of_icons <= 9) {
		$(icon).attr("src", "img/" + type + ".png");
		dayTemplateIconSpan.append(icon);
	} else if (nr_of_icons == 10 && !dayTemplateIconSpan.find('img[src="img/dots.png"]').length) {
		dayTemplateIconSpan.find('img:last').attr("src", "img/dots.png");
	}
};

/*
 * Toevoegen van een maand kalender icoon. We onderscheiden de categorieen
 * Aanvallen (rood), Incidentele medicatie & bijwerkingen (blauw) en
 * gebeurtenissen (groen).
 */
function setMonthIcon(type, date, dayTemplateIconSpan) {
	var icon = $('<img>').addClass("calendarMonthIcon");
	var iconName = "img/" + type;
	var iconExists = dayTemplateIconSpan.find(' img[src="' + iconName + '"]').length > 0;

	if (!iconExists) {
		$(icon).attr("src", iconName);
		dayTemplateIconSpan.append(icon);
	}
};

/*
 * Opbouwen van de weekcalender. De af te drukken week wordt opgeslagen in de
 * session storage.
 */
function buildWeekCalendar(targetItem, weekOffset) {

	// offset t.o.v. huidige week ophalen uit sessionStorage.
	var offset = weekOffset;

	// eerste dag van de week ophalen (maandag)
	var day = Date.today().is().monday() ? Date.today().addWeeks(offset) : Date.today().addWeeks(offset).previous().monday();

	$(targetItem).empty();
	var $dayTemplateCopy = $('.dayItem-template').clone().removeClass('dayItem-template');
	$dayTemplateCopy.find('#dayItemGrid').css('min-height', EP_calendar_week_itemHeight);

	for ( var i = 0; i < 7; i++) {
		var $dayTemplate = $dayTemplateCopy.clone();
		// ophalen template uit code en klasse aanpassen voor horizontale
		// positie
		if (i % 2 == 0) {
			$dayTemplate.addClass("ui-block-a");
		} else {
			$dayTemplate.addClass("ui-block-b");
		}

		// bij een jaarovergang het jaartal weergeven
		var previous_day = new Date();
		previous_day.setDate(day.getDate() - 1);
		var year = ((previous_day.getFullYear() - day.getFullYear()) != 0) ? day.getFullYear() : "";

		// vullen template
		$dayTemplate.find('#dayItemWeekday').html(day.toString('ddd'));
		$dayTemplate.find('#dayItemMonthYear').html(day.toString('MMM') + " " + year);
		$dayTemplate.find('#dayItemDay').html(day.getDate());
		var dayIconsTemplate = $dayTemplate.find('.dayItemIcons');
		dayIconsTemplate.attr('date', day.toDateString());
		$dayTemplate.find('a').attr('date', day.toDateString());

		drawWeekDayIcons(day, dayIconsTemplate);

		// toevoegen aan grid en naar volgende dag
		$(targetItem).append($dayTemplate.show());

		day.addDays(1);
	}

	// reset the day to the first of the week and fill the calendar with icons.
};

function drawWeekDayIcons(day, dayItemIconsTemplate) {

	// Teken multi-day events
	var mdEvents = getMultiDayEventsFor(day);
	for ( var mdEvent in mdEvents) {
		setWeekIcon(mdEvents[mdEvent].eventType.name, day, dayItemIconsTemplate);
	}

	// Teken event voor deze dag
	var dayEvents = getJSON(day.toDateString());
	// sorteer de events chronologisch
	if (dayEvents != null) {
		dayEvents.sort(sortBy('startDateTime', false, function(a) {
			return Date.parse(a).getTime();
		}));
	}

	for ( var e in dayEvents) {
		setWeekIcon(dayEvents[e].eventType.name, day, dayItemIconsTemplate);
	}
}

/*
 * Schrijft de week offset (relatief aan de huidige week) weg naar de session
 * storage.
 * 
 * @param direction: "next" of "previous" week. Bij weglaten wordt de huidige
 * week weggeschreven (offset=0).
 */
function setWeek(direction) {
	var old_offset = sessionStorage.getItem("selected_week");
	var new_offset = getOffsetFromDirection(old_offset, direction);
	sessionStorage.setItem("selected_week", new_offset);

	// shift the selected day by week offset
	var day = new Date();
	day.addWeeks(new_offset);
	sessionStorageWrapper().SetSelectedDay(day);
}
/*
 * De huidig geselecteerde week offset tov de huidige week
 */
function getWeek() {
	return parseInt(sessionStorage.getItem("selected_week"));
}

function setDay(direction) {
	var day = sessionStorageWrapper().GetSelectedDay();// Date.parse(sessionStorage.getItem("selected_day"));
	if (typeof direction === undefined || day === "null" || day === null) {
		// null when storage does not exist, NaN sometimes occurs when storage
		// is corrupted.
		day = new Date();
	}

	if (direction == "next") {
		day.addDays(1);
	} else if (direction == "previous") {
		day.addDays(-1);
	}
	sessionStorageWrapper().SetSelectedDay(day);
}

/*
 * De huidig geselecteerde week offset tov de huidige week
 */
function getMonth() {
	return parseInt(sessionStorage.getItem("selected_month"));
}

function setMonth(direction) {
	var old_offset = sessionStorage.getItem("selected_month");
	var new_offset = getOffsetFromDirection(old_offset, direction);
	sessionStorage.setItem("selected_month", new_offset);
}

function setSelectedCalendar(active) {
	sessionStorage.setItem("selected_calendar", active);
}

function getSelectedCalendar() {
	return sessionStorage.getItem("selected_calendar");
}

function getOffsetFromDirection(offset, direction) {
	if (direction == undefined || offset == "null" || offset == null || !$.isNumeric(offset) || offset == undefined) {
		// null when storage does not exist, NaN sometimes occurs when storage
		// is corrupted.
		return 0;
	}

	if (direction == "next") {
		return ++offset;
	} else if (direction == "previous") {
		return --offset;
	}

}

/*
 * KALENDER DAG PAGINA CODE VANAF HIER.
 */
$('#calendarDayPage').live('pagebeforeshow', function() {
	buildDayCalendar();
	// setSelectedCalendar('day');
});

function buildDayCalendar() {
	var date = sessionStorageWrapper().GetSelectedDay();
	var $target = $('#lvCalendarDayList');

	// zet pagina header
	$('#dagKalenderDatumHeader').html(date.toString(jQuery.i18n.prop('i18n_textbox_dateformat')));

	/*
	 * Ophalen van alle events voor deze dag.
	 */
	var events = getJSON(date.toDateString());
	if (events == null) {
		events = [];
	}
	
	/*
	 * Toevoegen van eigen medicijnen. Eerst worden alle medicijnen geconverteerd
	 * naar events voor de dag. Dat zijn maximaal 4 events per medicijn (ochtend
	 * middag avond nacht). Vervolgens wordt er gekeken of er per event een
	 * bijbehorend -afwijkende medicatie event- is geregistreerd. Is dat het
	 * geval, dan mag het medicijn event niet meer getoond worden.
	 */
	var filteredMedEvents = [];

	var meds = mijnMedicatieController.getAll();
	for ( var m in meds) {
		var medEvents = afwijkendeMedicatieController.convertToCustomMedicineEvents(meds[m], date);

		for (me in medEvents) {
			var afwijkendMedicijnFound = false;
			for (e in events) {
				if (events[e].eventType.name == "AfwijkendMedicijngebruik") {
					if (medEvents[me].time == events[e].time && medEvents[me].drugName == events[e].drugName) {
						afwijkendMedicijnFound = true;
						break;
					}
				}
			}

			if (!afwijkendMedicijnFound) {
				filteredMedEvents.push(medEvents[me]);
			}
		}

		//events.push.apply(events, filteredMedEvents);
	}

	/*
	 * Toevoegen van behandelschema medicijnen. Dit gaat op dezelfde manier als
	 * bij eigen medicijnen, alleen is de conversie anders omdat dit allemaal al
	 * losse innamemomenten zijn.
	 */
	var behandelschema = behandelschemaController.get();
	if (behandelschema != null && behandelschema.medicijnSchemas) {
		var medEvents = afwijkendeMedicatieController.convertBehandelSchemaToCustomMedicineEvents(behandelschema.medicijnSchemas, date);

		for (m in medEvents) {
			var afwijkendMedicijnFound = false;
			for (e in events) {
				if (events[e].eventType.name == "AfwijkendMedicijngebruik") {
					if (medEvents[m].time == events[e].time && medEvents[m].drugName == events[e].drugName
							&& events[e].behandelschemaServerId != undefined) {
						afwijkendMedicijnFound = true;
						break;
					}
				}
			}

			if (!afwijkendMedicijnFound) {
				filteredMedEvents.push(medEvents[m]);
			}
		}

	}

	events.push.apply(events, filteredMedEvents);

	// sorteer de events chronologisch
	// er is bij het sorteren een discrepantie tussen objecten die wel en niet
	// naar de local storage zijn geweest. De datum heeft dan namelijk een ander
	// format, en moet dan wel of niet geparsed worden om te kunnen vergelijken.
	// Als het object type == Object, dan is het naar de database geweest en moet
	// er worden geparsed, anders is de startDateTime property gewoon een object
	// en kan deze direct gebruikt worden.
	if (events != null) {
		events.sort(sortBy('startDateTime', false, function(a) {
			var parsedDate = Date.parseExact(a, "yyyy-MM-ddTHH:mm:ss");
			if (parsedDate && parsedDate != null) {
				return parsedDate.getTime();
			} else {
				return Date.parse(a).getTime();
			}
		}));
	}

	var multiDayEvents = getMultiDayEventsFor(date);

	$target.empty();

	for ( var j in multiDayEvents) {
		drawDayItem(multiDayEvents[j], true);
	}

	for ( var i in events) {
		drawDayItem(events[i]);
	}

	if (events == null && multiDayEvents.length == 0) {
		drawNoDataFoundItem($target, 'i18n_no_events_found');
	}

	$target.listview('refresh');
}

function drawNoDataFoundItem(targetList, i18n_text_variable) {
	var $listItem = $('<li class="contactListItem">').append($('<h4>').html(jQuery.i18n.prop(i18n_text_variable)));
	targetList.append($listItem);
}

function drawDayItem(event, isMultidayEvent) {
	var $eventTemplate = $('.timeEvent-template').clone().removeClass('timeEvent-template');
	$eventTemplate.addClass("timeEventListItem");
	$eventTemplate.attr('id', event.id);
	var eventDate = Date.parse(event.startDateTime);
	if (event.eventType.name == "Medicijngebruik" && event.behandelschemaServerId != undefined) {
		$eventTemplate.find('.timeEventCategoryIcon').attr('src', 'img/Behandelschema.png');		
	} else {
		$eventTemplate.find('.timeEventCategoryIcon').attr('src', 'img/' + event.eventType.name + '.png');		
	}
	
	// enkel de tijd tonen bij non-multiday events.
	if (!isMultidayEvent) {
		$eventTemplate.find('.timeEventTime').html(eventDate.toString("HH:mm"));
	}

	if (event.eventType.custom) {
		$eventTemplate.find('.timeEventCategoryTitle').html(event.eventType.eigenTitel);
	} else {
		$eventTemplate.find('.timeEventCategoryTitle').html(jQuery.i18n.prop(event.eventType.name));
	}

	if (event.eventType.name == "Medicijngebruik") {
		if (event.daypart) {
			$eventTemplate.attr('daypart', event.daypart);
		} else {
			$eventTemplate.attr('time', event.time);
		}
	}

	$eventTemplate.find('.timeEventCategoryDescription').html(getDayDescription(event));
	$eventTemplate.find('.timeEventLink').attr('href', '#edit' + event.eventType.name + "Link");

	$('#lvCalendarDayList').append($eventTemplate.show());
}

function getDayDescription(event) {
	switch (event.eventType.name) {
	case "Aanval":
		return jQuery.i18n.prop('i18n_day_description_seizure', event.strokeType, event.strokeCount, event.intensity, event.duration) + " "
				+ event.notes;
		break;
	case "IncidenteleMedicatie":
	case "Medicijngebruik":
		return getDrugDescription(event);
		break;
	case "AfwijkendMedicijngebruik":
		if (event.reason == "missed") {
			var text = [ jQuery.i18n.prop('i18n_missed'), ": ", event.drugName ];
			return text.join('');
		} else if (event.reason == "extra") {
			var text = [ jQuery.i18n.prop('i18n_extra_intake'), ": ", getDrugDescription(event) ];
			return text.join('');
		} else if (event.reason == "later") {
			var text = [ jQuery.i18n.prop('i18n_later_intake'), ": ", getDrugDescription(event) ];
			return text.join('');
		}
		break;
	case "Bijwerking":
		return event.name;
		break;
	default:
		return event.notes;
		break;
	}
}

function getDrugDescription(event) {
	var unit = jQuery.i18n.prop(getEnumByValue(EP_EVENT_INCIDENT_DRUG_UNIT, event.unit));
	return jQuery.i18n.prop('i18n_day_description_incidentaldrug', event.quantity, unit, event.drugName);
}

function redrawCalendar() {
	var thisWeek = getWeek();

	var current = $("#calendarWeekGrid")[0];
	buildWeekCalendar(current, thisWeek);
}

function redrawMonthCalendar() {
	var fieldset = $("#monthCalendarContainer > fieldset");
	var thisMonth = getMonth();
	buildMonthCalendar(fieldset, thisMonth);

	// shift the selected day by months
	var day = new Date();
	day.addMonths(thisMonth);
	sessionStorageWrapper().SetSelectedDay(day);
}

function goBackToCalendarPage() {
	var cal = getSelectedCalendar();
	if (cal == 'month') {
		navigationController.gotoPage("#calendarMonthPage");
	} else {
		// cal == week or undefined
		navigationController.gotoPage("#calendarWeekPage");
	}
}

/*
 * MONTH CALENDAR HERE
 */
$('#calendarMonthPage').live('pageinit', function() {
	$('.calendarHeader').find('.ui-select').addClass('header-combobox');

});

$('#calendarMonthPage').live('pagebeforeshow', function() {
	setSelectedCalendar('month');
	redrawMonthCalendar();
});

$('#calendarMonthPage').live('pageshow', function() {
	$('#select-calendar-month > option[value="month"]').attr('selected', "");
	$('#select-calendar-month').selectmenu('refresh');
});

/*
 * Opbouwen van de weekcalender. De af te drukken week wordt opgeslagen in de
 * session storage.
 */
function buildMonthCalendar(targetItem, monthOffset) {
	// eerste dag van de maand ophalen
	var targetMonth = Date.today().addMonths(monthOffset);
	var first_day = new Date(targetMonth.getFullYear(), targetMonth.getMonth(), 1, 0, 0, 0);
	$('#monthCalenderDatumHeader').html(targetMonth.toString('MMMM yyyy'));
	/*
	 * ls de eerste dag van de maand een maandag is, gebruik die, anders gebruik
	 * de laatste maandag van vorige maand als startpunt.
	 */
	var start_day = first_day.is().monday() ? first_day : first_day.last().monday();
	var day = new Date(start_day.getTime());

	$(targetItem).empty();
	var blocks = [ 'ui-block-a', 'ui-block-b', 'ui-block-c', 'ui-block-d', 'ui-block-e', 'ui-block-f', 'ui-block-g' ];

	var $template = $('.monthDayItem-template'); // template ophalen
	var html = [];

	// this from css
	// weekdays header
	var headerDate = new Date(day.getTime());
	for ( var i = 0; i < 7; i++) {
		var $dayTemplate = $template.clone().removeClass('monthDayItem-template').addClass(blocks[i % 7] + " monthDayItemHeader");
		$dayTemplate.find('#monthDayItemDay').html(headerDate.toString('ddd'));
		$dayTemplate.find('#monthDayIcons').remove(); // to make text center
		$dayTemplate.show();
		var itemHtml = $('<div>').append($dayTemplate.clone()).remove().html();
		html.push(itemHtml);
		headerDate.addDays(1);
	}

	first_day = new Date(targetMonth.getFullYear(), targetMonth.getMonth(), 1, 0, 0, 0); // reset
	// first_day
	/*
	 * aantal rijen van de kalender bepalen. 5 is default, en als de eerste op
	 * een zat. of zondag valt, 6 rijen. Enkele uitzondering is februari in een
	 * niet-schrikkeljaar: 4 rijen. Daarna de hoogte van de rijen laten afhangen
	 * van de hoogte van de viewport - header/footer (- spacing) / aantalRijen.
	 */
	var numberOfRows = 5;
	if (first_day.is().sunday() || first_day.is().saturday()) {
		numberOfRows = 6;
	} else if (first_day.is().february() && first_day.is().monday() && !first_day.isLeapYear()) {
		numberOfRows = 4;
	}

	var itemHeight = Math.floor(EP_calendar_month_availableHeightPixels / numberOfRows);
	var numberOfItems = (numberOfRows * 7);
	for ( var i = 0; i < numberOfItems; i++) {

		// ophalen template uit code en klasse aanpassen voor horizontale
		// positie
		var $dayTemplate = $template.clone().removeClass('monthDayItem-template').addClass(blocks[i % 7] + " monthDayItem");
		$dayTemplate.find('#monthDayItemGrid').css('min-height', itemHeight);
		if (targetMonth.getMonth() != day.getMonth()) {
			$dayTemplate.addClass('monthDarkDayItem');
		}

		// vullen template
		$dayTemplate.find('#monthDayItemDay').html(day.getDate());
		$dayTemplate.find('#monthDayIcons').attr('date', day.toDateString());
		$dayTemplate.find('a').attr('date', day.toDateString());

		// Iconen aan de dag toevoegen
		drawMonthDayIcons(day, $dayTemplate.find('#monthDayIcons'));

		$dayTemplate.show();
		// toevoegen aan grid en naar volgende dag
		var itemHtml = $('<div>').append($dayTemplate.clone()).remove().html();
		html.push(itemHtml);
		day.addDays(1);
	}

	$(targetItem).append(html.join(''));
};

function drawMonthDayIcons(day, dayTemplateIconSpan) {
	// Teken event voor deze dag
	var dayEvents = getJSON(day.toDateString());
	var hasColor = [];

	/*
	 * Teken alle gebeurtenissen van deze dag, als er al een gebeurtenis is met
	 * deze kleur kun je door naar de volgende en hoef je deze dus niet te
	 * tekenen.
	 */
	for ( var e in dayEvents) {
		var eventTypeName = getEventTypeName(dayEvents[e].eventType.name);

		if (hasColor[eventTypeName] == undefined) {
			setMonthIcon(eventTypeName, day, dayTemplateIconSpan);
			hasColor[eventTypeName] = 1;
		}
	}

	/*
	 * Als hierboven nog geen 'groene gebeurtenis' is getekend, ga dan de
	 * multiday events tekenen.
	 */
	if (hasColor[GREEN_DOT] == undefined) {
		var mdEvents = getMultiDayEventsFor(day);
		for ( var mdEvent in mdEvents) {
			var eventTypeName = getEventTypeName(mdEvents[mdEvent].eventType.name);

			if (hasColor[GREEN_DOT] == undefined) {
				setMonthIcon(eventTypeName, day, dayTemplateIconSpan);
				break;
			}
		}
	}

}

function getEventTypeName(eventType) {
	switch (eventType) {
	case "Aanval":
		return RED_DOT;
	case "IncidenteleMedicatie":
	case "Bijwerking":
		return BLUE_DOT;
	default:
		return GREEN_DOT;
	}
}

/*
 * Klikken op een dag in de maand kalender. Dag wordt uit de link gehaald en
 * opgeslagen in session storage en navigatie naar dagpagina.
 */
$('div[id="calendarMonthPage"] a[class="monthDayItemLink"]').live("click", function() {
	var date = new Date($(this).attr("date"));
	sessionStorageWrapper().SetSelectedDay(date);
	navigationController.gotoPage("#calendarDayPage");
});