/**
 * Controller voor Aanval gebeurtenissen.
 */
var aanvalController = epExtend(eventController, {

	/**
	 * Override. Vooraf datums/tijden prefillen op de bewerk pagina
	 */
	New : function() {
		this._super.New();

		var currentDateTime = this._super.getNewEventDate();

		$("#addAttackDate").val(currentDateTime.toDisplayDateString());
		$("#addAttackTime").val(currentDateTime.toDisplayTimeString());
		$("#addAttackNote").not(':submit').val('');
		fillAanvalCombobox();
		var typeNaam = $("#addAttackType").val();
		fillAanvalTypeBeschrijving(typeNaam);
		$('#addAttackIntensity').add("#addAttackDuration").val('1');
	},

	/**
	 * Override. Bewerk een bestaande aanval. De bewerk pagina wordt geopend en
	 * vooraf ingevuld.
	 * 
	 * @param epEventAttack
	 *            Het object dat moet worden gewijzigd.
	 */
	Edit : function(epEventAttack) {
		this._super.Edit(epEventAttack);

		navigationController.gotoPage("#editAanval");
		var dateTime = Date.parse(epEventAttack.startDateTime);

		// Vul form
		$("#addAttackDate").val(dateTime.toDisplayDateString());
		$("#addAttackTime").val(dateTime.toDisplayTimeString());
		$("#addAttackIntensity").val(epEventAttack.intensity);
		$("#addAttackDuration").val(epEventAttack.duration);
		$("#addAttackNote").val(epEventAttack.notes);
		fillAanvalCombobox(epEventAttack.strokeType);
		fillAanvalTypeBeschrijving(epEventAttack.strokeType);
	}
});

function fillAanvalTypeBeschrijving(aanvalTypeNaam) {
	var aanvalType = aanvalTypeController.Get(aanvalTypeNaam);
	var beschrijving = (aanvalType != null) ? aanvalType.description : "";
	$('#aanvalTypeBewerkenBeschrijving').html(beschrijving);
}

/**
 * @typenaam deze naam wordt gecheckt op bestaande aanvalTypes, en als die
 *           niet bestaat
 */
function fillAanvalCombobox(aanvalTypeNaam) {
	var combobox = $("#addAttackType");
	combobox.empty();
	
	var aanvalTypes = getJSON("epAanvalType");
	var lijst = [];
	var aanvalTypeExists = false;
	// Dynamisch vullen van aanval types
	for (a in aanvalTypes) {
		if (aanvalTypeNaam == aanvalTypes[a].typeName) {
			aanvalTypeExists = true;
		}
		var aanvalNaam = aanvalTypes[a].typeName;
		lijst.push("<option value='", aanvalNaam, "'>", aanvalNaam, "</option>");
	}
	
	/*
	 * Aanvaltype dat verwijderd is maar nog wel in de storage staat, aan de
	 * lijst toevoegen. Alleen als een extra aanvalstype als parameter aan
	 * de functie is meegegeven.
	 */
	if (aanvalTypeNaam && !aanvalTypeExists) {
			lijst.push("<option value='", aanvalTypeNaam, "'>", aanvalTypeNaam + "</option>");
	}

	combobox.append(lijst.join(""));;
	if (aanvalTypeNaam) {
		combobox.val(aanvalTypeNaam);		
	}
	
	combobox.selectmenu('refresh');
}



/**
 * Viewer functionaliteit voor aanval scherm
 */
$(function() {
	/*
	 * Zorg dat de edit pagina niet wordt opgenomen in de browser geschiedenis,
	 * zodat na het invoeren de gebruiker op de back knop kan klikken.
	 */
	$('#editAanvalLink').on('click', function() {
		navigationController.gotoPage("#editAanval", true);
		aanvalController.New();
	});

	/*
	 * Aanval form submission afhandelen
	 */
	$('#addAttackSubmit').on("click", function() {

		var strokeDate = $("#addAttackDate").val();
		var strokeTime = $("#addAttackTime").val();
		var strokeType = $("#addAttackType").val();
		var startTime = Date.parse(strokeDate + " " + strokeTime);
		var endTime = Date.parse(strokeDate + " " + strokeTime);
		var stroke = new epEventStroke(startTime, strokeType);

		// Retrieve all filled in fields
		stroke.strokeCount = 1;
		stroke.intensity = $("#addAttackIntensity").val();
		stroke.duration = $("#addAttackDuration").val();
		stroke.eindDateTime = endTime.addMinutes(stroke.duration);
		stroke.notes = $("#addAttackNote").val();

		if (eventController.getAction() == ACTION.Edit) {
			aanvalController.update(stroke);
		} else {
			aanvalController.save(stroke);
		}
		aanvalController.Clear();

		navigationController.gotoPreviousPage();
		return false;
	});

	$('#addAttackType').on('change', function() {
		var typeNaam = $(this).val();
		fillAanvalTypeBeschrijving(typeNaam);
	});
});
