var aanvalTypeController = epExtend(controller, {

	/**
	 * Override. Aanmaken nieuw aanvalType. Clear form en verwijder delete knop.
	 */
	New : function() {
		this._super.New();
		$("#aanvalTypeNaam").val('');
		$("#aanvalTypeBeschrijving").val('');		
		$("#aanvalTypeDeleteButton").hide();
	},

	/**
	 * Override. Bewerken bestaand aanvaltype.
	 */
	Edit : function(aanvalType) {
		this._super.Edit(aanvalType);

		navigationController.gotoPage("#aanvalTypeBewerkenPage");
		$("#aanvalTypeNaam").val(aanvalType.typeName);
		$("#aanvalTypeBeschrijving").val(aanvalType.description);		
		$("#aanvalTypeDeleteButton").show();
	},
	
	Get : function(typeName) {
		var aanvalTypes = getJSON('epAanvalType');
		for (var a in aanvalTypes) {
			if (aanvalTypes[a].typeName == typeName) {
				return aanvalTypes[a];
			}
		}
	}

});

/**
 * Viewer functionaliteit. Afhandelen en instellen van event(handlers).
 */
$(function () {
    /**
    * Eerste keer openen van de pagina gebruiken om de overview lijst te laden.
    */
    $("#aanvalTypesPage").on("pageinit", function () {
        createAanvalTypeOverview(false);
    });

    /**
    * Afhandelen 'Nieuw' aanval type knop.
    */
    $("#aanvalTypeToevoegenLink").on("click", function () {
        navigationController.gotoPage("#aanvalTypeBewerkenPage");
        aanvalTypeController.New();
    });

    /**
    * Afhandelen submit van aanval form. Zowel 'Nieuw' als 'Edit'.
    */
    $("#aanvalTypeSubmit").on("click", function () {
        var typeNaam = $("#aanvalTypeNaam").val();
        var beschrijving = $("#aanvalTypeBeschrijving").val();
        
        if (typeNaam === "") {
            var message = $.i18n.prop("i18n_validation_error_seizuretype_name");
            phoneAlert(message);
            return false;
        }

        var aanvalType = new epAanvalType(typeNaam);
        aanvalType.description = beschrijving;

        if (aanvalTypeController.getAction() == ACTION.Edit) {
            aanvalTypeController.update(aanvalType);
        } else {
            aanvalTypeController.save(aanvalType);
        }

        // lijst leegmaken en opnieuw opbouwen
        createAanvalTypeOverview(true);

        navigationController.gotoPage("#aanvalTypesPage");
    });

    /**
    * Verwijderen van een bestaand aanval Type.
    */
    $('#aanvalTypeDeleteButton').on('click', function () {
        if (getJSON("epAanvalType").length == 1) {
            phoneAlert(jQuery.i18n.prop('i18n_alert_delete_lastseizuretype'));
            return false;
        }

        var onConfirm = function () {
            aanvalTypeController.Delete();
            createAanvalTypeOverview(true);
            navigationController.gotoPage("#aanvalTypesPage", true);
        };
        phoneConfirm($.i18n.prop('i18n_confirm_delete_seizuretype'), onConfirm);

        return true;
    });

});

/**
 * Genereren van de overzichts lijst met aanval types. Registreer per aanvalType
 * een click handler om vervolgens op de aanvalType bewerken pagina uit te
 * komen.
 * 
 * @param recreate
 *            Geef true mee als de lijst al bestond en opnieuw moet worden
 *            opgebouwd. Anders false.
 */
function createAanvalTypeOverview(recreate) {
	if (recreate)
		$("#aanvalTypesOverview").empty();

	createStandaardAanval();

	// lijst opbouwen
	var lijst = [];
	var html1 = '<li class="aanvalTypeItem" id="';
	var html2 = '"><img class="aanvalIcon" src="img/Aanval.png"/><h3>';
	var html3 = "</h3></li>";

	var aanvalTypes = getJSON("epAanvalType");
	var aanvalTypeLength = aanvalTypes.length;
	
	for ( var i = 0; i < aanvalTypeLength; i++) {
		lijst.push(html1, aanvalTypes[i].id, html2, aanvalTypes[i].typeName, html3);
	}
	$("#aanvalTypesOverview").append(lijst.join(""));
	$("#aanvalTypesOverview").listview("refresh");

	// onclick per list item registreren
	$("#aanvalTypesOverview > li").each(function() {
		$(this).on("click", function() {
			var aanvalType = getJSON("epAanvalType", $(this).attr('id'));
			aanvalTypeController.Edit(aanvalType);
		});
	});
}

function createStandaardAanval() {
	var aanvalTypes = getJSON("epAanvalType");

	// Standard aanvaltype opslaan als er niks is ingesteld
	if (aanvalTypes == null || aanvalTypes == undefined) {
		var aanvalType = new epAanvalType(jQuery.i18n.prop('i18n_aanval_eenvoudig'));
		aanvalTypes = [];

		storeJSON(aanvalType);
		aanvalTypes.push(aanvalType);
	}
}