
var timer = null;
var failureRetries = 0;

var followMeController = {
		
	followMeSessionId : null,
	
	start : function() {
		var bio = getOrCreateBio();
		var currentDate = new Date();
		var recipients = [];
		var contacts = contactenController.getAll();
		for (c in contacts) {
			if (contacts[c].isFollower) {
				var recipient = {
					"name" : contacts[c].name,
					"number" : contacts[c].phoneNumber,
					"email" : contacts[c].email
				};
				recipients.push(recipient);
			}
		}

        if (window.plugins != undefined && window.plugins.PowerManagement != undefined) {
            window.plugins.PowerManagement.acquire(function() {
                console.log('lock acquired');
            }, function() {
                console.log('no lock acquired');
            });
        } else {
            console.log('Cannot prevent screen from locking: no powermanagement available');
        }
        
		/* 
		 * Create JSON message: startfollowme
		 */
		var json_message_startfollowme = {
			"user" : bio.email,
			"timestamp" : currentDate.getTime(),
			"message" : jQuery.i18n.prop('i18n_followme_message', bio.name),
			"recipients" : recipients
		};
		
		serviceController.sendRequest(EP_FOLLOWME_SERVICE_ENDPOINT, EP_FOLLOWME_ACTION_START, json_message_startfollowme, followMeController.startSuccess, followMeController.updateLocationError);
		
		$("#debugGpsIcon").show();
	},	
	
	/**
	 * Success callback die wordt aangeroepen als de ajax post naar de server
	 * gelukt is.
	 * 
	 * @param jqXHR
	 */
	startSuccess : function(response) {
		if(response && response.status === "ERROR") {
			phoneAlert($.i18n.prop('i18n_followme_errorstart')  + " - " + response.message);
			return;
		}
		
		followMeController.followMeSessionId = response.followmesessionid;
		gpsTracker.start();
		timer = followMeController.updateLocation(EP_FOLLOWME_SYNC_FREQUENCY_SECONDS);
		followMeController.setStatusText(jQuery.i18n.prop('i18n_followme_gps_searching'));
	},
	
	stop : function() {
        if (window.plugins != undefined && window.plugins.PowerManagement != undefined) {
            window.plugins.PowerManagement.release();
        }
        
        var currentDate = new Date();
		var json_message_stopfollowme = {
			      "followmesessionid" : followMeController.followMeSessionId,
			      "timestamp" : currentDate.getTime()
			};
		serviceController.sendRequest(EP_FOLLOWME_SERVICE_ENDPOINT, EP_FOLLOWME_ACTION_STOP, json_message_stopfollowme, followMeController.stopSuccess, followMeController.updateLocationError);
	},
		
	/**
	 * Success callback die wordt aangeroepen als de ajax post naar de server
	 * is gelukt.
	 * 
	 * @param jqXHR
	 */
	stopSuccess : function(response) {
		if(response && response.status === "ERROR") {
			phoneAlert($.i18n.prop('i18n_followme_errorstop')  + " - " + response.message);
			return;
		}
		
		followMeController.followMeSessionId = null;
		gpsTracker.stop();
		clearInterval(timer);
		$("#debugGpsIcon").hide();
		$('#debugGpsIcon').attr('src', "img/" + RED_DOT);
		followMeController.setStatusText(jQuery.i18n.prop('i18n_followme_gps_off'));
	},
		
	/**
	 * Synchroniseer de verzamelde gps coordinaten naar de server.
	 */
	updateLocation : function(interval) {
		console.log("FOLLOWME: invoked with interval: " + interval);
		var intervalOrig = interval;

		var syncTimer = setInterval(function() {
            //console.log("still in interval function, interval is: " + interval + "orig interval is: " + intervalOrig);
			if (interval <= 0) {
				if (navigator.userAgent.toLowerCase().match(/iphone/) || navigator.userAgent.toLowerCase().match(/ipad/)) {
					gpsTracker.pollIphoneLocation();
				}
				// Klaar met aftellen, probeer naar de server te syncen.
				var geo = gpsTracker.getGeo();
				if (geo != null && geo.points.length > 0) {
					interval = intervalOrig;
					var json_points = [];
					for (i in geo.points) {
						point = geo.points[i];
						var json_point = {
								"timestamp" : point.timestamp,
								"latitude" : point.latitude,
								"longitude" : point.longitude
						};
						json_points.push(json_point);
					}
					var json_message_updatelocation = {
							"followmesessionid" : followMeController.followMeSessionId,
							"points" : json_points
					};
					
					serviceController.sendRequest(EP_FOLLOWME_SERVICE_ENDPOINT, EP_FOLLOWME_ACTION_UPDATELOCATION, json_message_updatelocation, followMeController.updateLocationSuccess, followMeController.updateLocationError);
				}
			}
			interval--;
		}, 1000);
		
		return syncTimer;
	},
	
	/**
	 * Als de server sync succesvol is gooien we de parameters leeg en bouwen we
	 * de array opnieuw op.
	 * 
	 * @param geo
	 */
	updateLocationSuccess : function(response) {
		if(response && response.status === "ERROR") {
			console.log("Fout bij versturen locatiegegevens: " + response.message );
			return;
		}
		
		if (gpsTracker.hasSignal) {
			if (gpsTracker.geo.accuracy <= EP_GPS_MIN_ACCURACY_METERS) {
				$('#debugGpsIcon').attr('src', "img/" + GREEN_DOT);
				followMeController.setStatusText(jQuery.i18n.prop('i18n_followme_goodconnection'));
			} else {
				$('#debugGpsIcon').attr('src', "img/" + BLUE_DOT);
				followMeController.setStatusText(jQuery.i18n.prop('i18n_followme_badconnection'));
			}			
		} else {
			$('#debugGpsIcon').attr('src', "img/" + RED_DOT);			
			$('#debugGps').html(jQuery.i18n.prop('i18n_followme_noconnection'));
		}
		
		gpsTracker.clearPoints();
	},
	
	/**
	 * Error callback die wordt aangeroepen als de ajax post naar de server
	 * mislukt.
	 * 
	 * @param jqXHR
	 */
	updateLocationError : function(jqXHR) {
		$('#debugGpsIcon').attr('src', "img/" + RED_DOT);
		if (gpsDebug) {
			console.log("FOLLOWME: syncError - " + JSON.stringify(jqXHR));
			followMeController.setStatusText("SYNC ERROR: " + JSON.stringify(jqXHR));			
		} else {
			followMeController.setStatusText(jQuery.i18n.prop('i18n_followme_noserverconnection'));						
		}
	},	
		
	setStatusText : function(customText) {
		if (gpsDebug) {
			signalText = " -- last gps signal: " + gpsTracker.lastSignal + "s ago.";
			if (customText == undefined) {
				$('#debugGps').html(debugText + signalText);
			} else {
				$('#debugGps').html(debugText + signalText + " " + customText);				
			}
		} else {
			$('#debugGps').html(customText);
		}
	},
	
};

$(function() {

	$("#followMePage").on("pageinit", function() {
		var gpsOn = (watchID == null) ? false : true;
		$('input[id="follow-choice-on"]').prop('checked', gpsOn).checkboxradio('refresh');
		$('input[id="follow-choice-off"]').prop('checked', !gpsOn).checkboxradio('refresh');
		if (gpsOn) {
			$('#ikOpDeKaartLink').show();
		}
	});

	$("#flipFollowMe").on("change", function() {
		var isEnabled = $('input[id="follow-choice-on"]').is(':checked');
		if (isEnabled) {
			$('#ikOpDeKaartLink').show();
			followMeController.start();
		} else {
			$('#ikOpDeKaartLink').hide();
			followMeController.stop();
		}
	});
});