$(function() {
	document.addEventListener("backbutton", onBackKeyDown, false);

	/*
	 * De android backbutton stuurt je altijd terug naar de vorige pagina binnen
	 * een van de vijf gebieden die onderin de navbar staan: calendar, report,
	 * settings, help, en alarm. Binnen elk van deze subdomeinen wordt een
	 * breadcrumb-spoor bijgehouden, bij herhaaldelijk op de backknop drukken
	 * eindig je altijd bij dezelfde pagina die direct onder de knop zit.
	 */
	function onBackKeyDown() {
		navigationController.gotoPreviousPage();
	}
	/*
	 * Android bugfix: als je enter drukt op het softkeyboard word form submit
	 * getriggerd. Hiermee wordt dit afgevangen. De opslaan toets moet hiervoor
	 * gebruikt worden.
	 */
	$('*').submit(function() {
		return false;
	});

	$("#mainPage").on('pagebeforeshow', function() {
		// reset date selection when main menu is shown
		sessionStorageWrapper().SetSelectedDay(null);
	});

	var ua = navigator.userAgent.toLowerCase();
	if (ua.match(/android/) || ua.match(/iphone/) || ua.match(/ipad/)) {
		$('.nativedatepicker').attr('readonly', 'readonly');
		$('.nativetimepicker').attr('readonly', 'readonly');
	}

	$('.nativedatepicker').click(function(event) {
		var currentField = $(this);
		var myNewDate = Date.parse(currentField.val()) || new Date();

		// Same handling for iPhone and Android
		if (window.plugins != undefined && window.plugins.datePicker != undefined) {
			window.plugins.datePicker.show({
				date : myNewDate,
				mode : 'date', // date or time or blank for both
				allowOldDates : true
			}, function(returnDate) {
				var newDate = new Date(returnDate);
				currentField.val(newDate.toString("dd/MMM/yyyy"));
			});
		}
	});

	$('.nativetimepicker').click(function(event) {
		var currentField = $(this);
		var time = currentField.val();
		var myNewTime = new Date();

		var timeArr = time.split(":");
		if (timeArr[1] != undefined) {
			myNewTime.setHours(timeArr[0]);
			myNewTime.setMinutes(timeArr[1]);
		}

		// Same handling for iPhone and Android
		if (window.plugins != undefined && window.plugins.datePicker != undefined) {
			plugins.datePicker.show({
				date : myNewTime,
				mode : 'time', // date or time or blank for both
				allowOldDates : true
			}, function(returnDate) {
				var newDate = new Date(returnDate);
				currentField.val(newDate.toString("HH:mm"));
			});
		}
	});

	/**
	 * Preload side_effect quicklist & medicine quicklist
	 */
	refreshBijwerkingenList();
	refreshMedicineList();

	$("#tellafriend_sendmail").click(function(event) {
		EmailAFriend();
	});
	
	$("#requestCountry").click(function(event) {
		EmailCountryRequest();
	});

	$('#navbarCalendarLink').live('click', function() {
		navigationController.gotoPage('#calendarWeekPage');
	});

	$('#navbarReportLink').live('click', function() {
		navigationController.gotoPage('#reportPage');
	});

	$('#navbarSettingsLink').live('click', function() {
		navigationController.gotoPage('#settingsPage');
	});

	$('#navbarHelpLink').live('click', function() {
		navigationController.gotoPage('#helpScherm');
	});

	/*
	 * Deze niet tap want je wil de knop ingedrukt kunnen houden.
	 */
	$('#navbarAlarmLink').live('click', function() {
		navigationController.gotoPage('#alarmScherm');
	});

});

function refreshBijwerkingenList() {
	var settings = getSettings();
	var fileName = [ "data/bijwerkingen/", "bijwerkingen-", settings.language, ".json" ];
	loadJSONFileToList(fileName.join(''), '#sideEffectList');
}

function refreshMedicineList() {
	/**
	 * Preload side_effect quicklist
	 */
	var settings = getSettings();
	var medicineList = settings.medicinelist;

	// this only happens on dev machines..new settings always have a medicine
	// list
	if (typeof medicineList === "undefined") {
		medicineList = "nl-NL"; //
	}
	var fileName = "data/druglist/" + medicineList + ".json";
	loadJSONFileToList(fileName, '#incidentDrugList');

}

function EmailAFriend() {
	var url = $.i18n.prop('i18n_tellafriendurl');
	var html = $.i18n.prop('i18n_tellafriend_mail_body');
	var subject = jQuery.i18n.prop('i18n_tellafriend_mail_subject');
	var appstore = $.i18n.prop('i18n_tellafriend_mail_appstore');
	var appstoretext = $.i18n.prop('i18n_tellafriend_mail_appstoretext');
	var playstore = $.i18n.prop('i18n_tellafriend_mail_playstore');
	var playstoretext = $.i18n.prop('i18n_tellafriend_mail_playstoretext');
	
	var body = '<h3>' + subject + '</h3><p>' + html + '</p>';
	body += '<a href="' + appstore + '">' + appstoretext + '</a><br/><br/>'; 
	body += '<a href="' + playstore + '">' + playstoretext + '</a>'; 
	
	QuintorPhonegapPlugins.sendEmail('', subject, body);
}

function EmailCountryRequest() {
	var url = $.i18n.prop('i18n_tellafriendurl');
	var html = $.i18n.prop('i18n_tellafriend_mail_body');
	var subject = jQuery.i18n.prop('Language request');
	
	var body = 'Requested Language: ...<br/><br/>Requested Country: ...';
	
	QuintorPhonegapPlugins.sendEmail('eppy@epilepsiefonds.nl', subject, body);
}
