var navigationController = {

	getCrumbs : function() {
		var jsonString = window.sessionStorage.getItem('breadcrumbs');
		if (jsonString != null) {
			var breadcrumbs = JSON.parse(jsonString);
			if (breadcrumbs != null) {
				return breadcrumbs;
			}
		}

		return [];
	},

	setCrumbs : function(breadcrumbs) {
		var jsonString = JSON.stringify(breadcrumbs);
		window.sessionStorage.setItem('breadcrumbs', jsonString);
	},

	updateFooter : function(targetPageId) {

		var newPage = $('.navbar-epp').find('a[epp-page*="' + targetPageId + '"]');
		if (newPage.length > 0) {
			$('.navitem a').not($(this)).parent().removeClass("navitem-active");
			// remove previous active buttons
			 $('.navbar-epp').find('a').removeClass('ui-btn-active');
			newPage.addClass('ui-btn-active');
			newPage.parent().addClass('navitem-active');
		}
	},

	handleBreadcrumbs : function(targetPageId) {
		var breadcrumbs = this.getCrumbs();
		switch (targetPageId) {
		case "#calendarWeekPage":
		case "#reportPage":
		case "#settingsPage":
		case "#helpScherm":
		case "#alarmScherm":
		case "#lockPage":
			breadcrumbs = [];
			break;
		default:
			if ($.mobile.activePage) {
				var currentPageId = '#' + $.mobile.activePage[0].id;
				if (breadcrumbs[breadcrumbs.length - 1] != currentPageId) {
					breadcrumbs.push(currentPageId);
				}
			}
			break;
		}
		this.setCrumbs(breadcrumbs);
	},

	handleNavigation : function(targetPageId, noCrumb) {
		this.updateFooter(targetPageId);
		if (!noCrumb) {
			this.handleBreadcrumbs(targetPageId);
		}
	},

	popCrumb : function() {
		var currentPageId = '#' + $.mobile.activePage[0].id;
		var breadcrumbs = this.getCrumbs();
		if (breadcrumbs.length > 0) {
			do {
				var targetPageId = breadcrumbs.pop();
			} while (targetPageId == currentPageId);

			this.setCrumbs(breadcrumbs);
			return targetPageId;
		} else {
			return currentPageId;
		}
	},

	gotoPreviousPage : function() {
		var oldPageId =  '#' + $.mobile.activePage[0].id;
		var newPageId = this.popCrumb();
		
		console.log('old page id: ' + oldPageId);
		console.log('new page id: ' + newPageId);
		if(newPageId !== oldPageId ) {
			$.mobile.changePage(newPageId);
		} else {
			if(oldPageId !== '#calendarWeekPage') {
				// terug naar kalender view als laatste back optie, daarna wel exit
				this.gotoPage('#calendarWeekPage', true);
			} else {
				// quit application 
				navigator.app.exitApp();
			}
		}
	},

	/**
	 * ga naar de meegegeven pagina. Optioneel: neem de huidige pagina (source
	 * page) niet op in breadcrumbs. Default dus wel!
	 * 
	 * @param pageId
	 *            #targetId
	 * @param noCrumb
	 *            bool
	 */
	gotoPage : function(pageId, noCrumb) {
		if (!noCrumb) {
			this.handleNavigation(pageId, noCrumb);
		}
		$.mobile.changePage(pageId);
		this.updateFooter(pageId);
	}
};