/*-
 * Phonegap Omniture Plugin for Android
 *
 * Created by Daniel van 't Oever
 *
 */
if (!PhoneGap.hasResource("Omniture")) {
	PhoneGap.addResource("Omniture");

	PhoneGap.addConstructor(function() {
		if (!window.plugins) {
			window.plugins = {};
		}
		window.plugins.Omniture = new Omniture();
	});

	/**
	 * Empty constructor
	 */
	var Omniture = function() {
	};

	/**
	 * Initialiseer de tracker
	 */
	Omniture.prototype.init = function() {
		console.log("JS: Omniture init aangeroepen");
		PhoneGap.exec(null, null, 'Omniture', 'initOmniture', new Array({
			'userId' : ""
		}));
	};

	/**
	 * Track application launch
	 */
	Omniture.prototype.trackLaunch = function(userId) {
		console.log("JS: Omniture track launch aangeroepen");
		PhoneGap.exec(null, null, 'Omniture', 'trackLaunch', new Array({
			'userId' : userId
		}));
	};

	/**
	 * Track alarm invocation
	 */
	Omniture.prototype.trackAlarm = function(userId) {
		console.log("JS: Omniture track alarm aangeroepen");
		PhoneGap.exec(null, null, 'Omniture', 'trackAlarm', new Array({
			'userId' : userId
		}));
	};

	/**
	 * Track agenda invocation
	 */
	Omniture.prototype.trackAgenda = function(userId, agendaCount) {
		console.log("JS: Omniture trackAgenda aangeroepen");
		PhoneGap.exec(null, null, 'Omniture', 'trackAgenda', new Array({
			'userId' : userId,
			'agendaCount' : agendaCount
		}));
	};

	/**
	 * Track medication invocation
	 */
	Omniture.prototype.trackMedication = function(userId, medicineCount) {
		console.log("JS: Omniture trackMedication aangeroepen");
		PhoneGap.exec(null, null, 'Omniture', 'trackMedication', new Array({
			'userId' : userId,
			'medicineCount' : medicineCount
		}));
	};

}