/*-
 * Phonegap Omniture Plugin for iOS
 *
 * Created by Daniel van 't Oever 2012 MIT Licensed
 *
 */
if( !PhoneGap.hasResource("Omniture") ) {
	PhoneGap.addResource("Omniture");
	
	PhoneGap.addConstructor(function() {
                            if (!window.plugins) {
                            window.plugins = {};
                            }
                            window.plugins.Omniture = new Omniture();
                            });
	
	/**
	 * Empty constructor
	 */
	var Omniture = function() {
	};
    
	/**
	 * Initialiseer de tracker
	 */
	Omniture.prototype.init = function() {
		console.log("JS: Omniture init aangeroepen");
		PhoneGap.exec('Omniture.initOmniture');
	};
	
	/**
	 * Track application launch
	 */
	Omniture.prototype.trackLaunch = function(userId) {
		console.log("JS: Omniture track launch aangeroepen");
		PhoneGap.exec('Omniture.trackLaunch', { 'userId': userId });
	};
    
    /**
	 * Track alarm invocation
	 */
	Omniture.prototype.trackAlarm = function(userId) {
		console.log("JS: Omniture track alarm aangeroepen");
		PhoneGap.exec('Omniture.trackAlarm', { 'userId': userId });
	};
    
    /**
	 * Track agenda invocation
	 */
	Omniture.prototype.trackAgenda = function(userId, agendaCount) {
		console.log("JS: Omniture trackAgenda aangeroepen");
		PhoneGap.exec('Omniture.trackAgenda', { 'userId': userId,'agendaCount' : agendaCount });
	};
    
    /**
	 * Track medication invocation
	 */
	Omniture.prototype.trackMedication = function(userId, medicineCount) {
		console.log("JS: Omniture trackMedication aangeroepen");
		PhoneGap.exec('Omniture.trackMedication', { 'userId': userId,'medicineCount' : medicineCount });
	};
    
}