var QuintorPhonegapPlugins = {

	/**
	 * Verstuur een email. Op de client wordt de mailclient geopend (of de
	 * gebruiker kan kiezen met welke client hij de mail wil openen). In de
	 * mailclient staat de mail en subject ingevuld.
	 * 
	 * @param subject
	 * @param body
	 */
	sendEmail : function(receipient, subject, body) {
		if (window.device != undefined && window.device.platform == "Android") {
			this.sendEmailAndroid(receipient, subject, body);
		} else {
			var mail_url = this.createMailUrl(receipient, subject, body);
			window.open(mail_url, '_self');
		}
	},

	/**
	 * Verstuur een email via de Android webintent plugin
	 * 
	 * @param subject
	 * @param body
	 */
	sendEmailAndroid : function(receipient, subject, body) {
		var extras = {};
		extras[WebIntent.EXTRA_SUBJECT] = subject;
		extras[WebIntent.EXTRA_EMAIL] = receipient;
		extras[WebIntent.EXTRA_TEXT] = body;
		window.plugins.webintent.startActivity({
			action : WebIntent.ACTION_SEND,
			type : 'text/html',
			extras : extras
		}, function() {
		}, function() {
			// alert('Failed to send email via Android Intent');
		});
	},

	/**
	 * Zend een background sms, als dat niet kan (afh. van platform) stuur dan
	 * een sms via de sms composer van het apparaat. Dan moet de gebruiker
	 * alleen nog op "send" drukken.
	 */
	sendSms : function(phoneNumbers, message, successCallback, failureCallback) {
		if (window.device != undefined && window.device == "Android") {
			return PhoneGap.exec(successCallback, failureCallback, 'SmsPlugin', "SendSMS", [ phoneNumbers, message ]);
		} else {
			window.location = this.createSmsUrl(phone, message);
		}
	},

	/**
	 * Maakt een sms: url opbasis van de gegeven telefoonnummers en bodytekst.
	 * 
	 * @param phoneNumbers
	 * @param message
	 * @returns
	 */
	createSmsUrl : function(phoneNumbers, message) {
		return [ "sms:", phoneNumbers, "?body=", message ].join('');
	},
	
	createMailUrl : function(address, subject, body) {
		return 'mailto:' + address + '?subject=' + escape(subject) + '&body=' + escape(body);
	}
};

function iphoneDatePickerCB(date) {
	console.log(date.toString());
}

function showIphoneDatePicker(mode) {
	plugins.datePicker.show({
		date : new Date(),
		mode : mode, // date or time or blank for both
		allowOldDates : true
	}, iphoneDatePickerCB);
}

// var SmsPlugin = function () {
//	 
// };
//
// SmsPlugin.prototype.sendSMS = function (successCallback, failureCallback,
// phone, message) {
// return PhoneGap.exec(successCallback, failureCallback, 'SmsPlugin',
// "SendSMS", [phone, message]);
// };
