function ResizePageContentHeight(page) {
	var $page = $(page),
		$content = $page.children( ".ui-content" ),
		hh = $page.children( ".ui-header" ).outerHeight() || 0,
		fh = $page.children( ".ui-footer" ).outerHeight() || 0,
		pt = parseFloat($content.css( "padding-top" )),
		pb = parseFloat($content.css( "padding-bottom" )),
		wh = window.innerHeight;
		
	$content.height(wh - (hh + fh) - (pt + pb));
}

$( ":jqmData(role='page')" ).live( "pageshow", function(event) {
	var $page = $( this );

	// For the demos that use this script, we want the content area of each
	// page to be scrollable in the 'y' direction.

	//useScrollView is disable for chrome because of issues with input elements
	if (!window.useScrollViewOnUiContent)
	{
		return;		
	}
	

	// This code that looks for [data-scroll] will eventually be folded
	// into the jqm page processing code when scrollview support is "official"
	// instead of "experimental".

	$page.find( ":jqmData(scroll):not(.ui-scrollview-clip)" ).each(function () {
		var $this = $( this );
		// XXX: Remove this check for ui-scrolllistview once we've
		//      integrated list divider support into the main scrollview class.
		if ( $this.hasClass( "ui-scrolllistview" ) ) {
			$this.scrolllistview();
		} else {
			var st = $this.jqmData( "scroll" ) + "",
				paging = st && st.search(/^[xy]p$/) != -1,
				dir = st && st.search(/^[xy]/) != -1 ? st.charAt(0) : null,

				opts = {
					direction: dir || undefined,
					paging: paging || undefined,
					scrollMethod: $this.jqmData("scroll-method") || undefined
				};

			$this.scrollview( opts );
		}
	});

	// For the demos, we want to make sure the page being shown has a content
	// area that is sized to fit completely within the viewport. This should
	// also handle the case where pages are loaded dynamically.

	ResizePageContentHeight( event.target );
});

$( window ).bind( "orientationchange", function( event ) {
	ResizePageContentHeight( $( ".ui-page" ) );
});

/* Code below is to make sliders work in scrollview
See : https://github.com/jquery/jquery-mobile/issues/2072
To make the slider work you should add the class 'noscroll' to the container div.
*/
(function ($) {
 $.fn.extend({
     isChildOf: function (filter_string) {

         var parents = $(this).parents().get();

         for (j = 0; j < parents.length; j++) {
             if ($(parents[j]).is(filter_string)) {
                 return true;
             }
         }

         return false;
     }
 });
})(jQuery);

$(function () {
 document.addEventListener('touchmove', function (e) { if (!IsSlider()) { e.preventDefault(); } }, true);
});


var hd = $.mobile.scrollview.prototype._handleDragStart;
var hm = $.mobile.scrollview.prototype._handleDragMove;
var hu = $.mobile.scrollview.prototype._handleDragStop;

function IsSlider(e) {
 var element = $(e);
 return element.hasClass('ui-slider')
   || element.hasClass('noscroll')
   || element.isChildOf('.noscroll');
}

$.mobile.scrollview.prototype._handleDragStart = function (e, x, y) {
 if (IsSlider(e.target)) return;

 hd.call(this, e, x, y);
};

$.mobile.scrollview.prototype._handleDragMove = function (e, x, y) {
 if (IsSlider(e.target)) {
     e.preventDefault();

     return;
 }

 hm.call(this, e, x, y);
};

$.mobile.scrollview.prototype._handleDragStop = function (e) {
 if (IsSlider(e.target)) return;

 hu.call(this, e);
};
/* End of slider code */