var SETTINGS;

function initializeSettings() {
	// create a dictioary lookup of language->lists.
	var medicinelists = new Array();
	// one option for nl
	medicinelists['nl'] = [ {
		name : "Nederland",
		data : 'nl-NL'
	} ];
	// two options for english
	medicinelists['en'] = [ {
		name : "Netherlands",
		data : 'en-NL'
	}, {
		name : "Great Britain",
		data : 'en-GB'
	} ];

	var pinChanged = false;
	var doReload = false;

	var rebuildMedicineList = function(language) {
		var medicineList = $("#select_medicine_list");
		medicineList.html("");
		for (var i = 0; i < medicinelists[language].length; i++) {
			var option = medicinelists[language][i];
			// add option to select list
			medicineList.append($('<option>', {
				value : option.data
			}).text(option.name));
		}
		medicineList.selectmenu('refresh', true);
		/*
		 * var selected = settings.medicinelist; if (typeof selected ===
		 * "undefined") { selected = "nl-NL"; }
		 */

		// $("#select_medicine_list option[value='" + selected +
		// "']").attr('selected', 'selected');
	};

	$('#settingsPage').live('pageshow', function() {
		// disable pinfields to prevent clickthrough and keyboard poppin up
		$("#pin2text").attr('disabled', 'disabled');
		$("#pin1text").attr('disabled', 'disabled');
	});

	$('#preferencesPage').live('pageinit', function () {
	    pinChange = false;
	    doReload = false;

	    /**
	    * Save settings afhandelen.
	    */
	    $("#settingsApply").click(function () {
	        if (validateOK()) {
	            saveSettings();
	        }
	    });

	    $("#btn_erase_all").click(function () {
	        phoneConfirm(jQuery.i18n.prop('i18n_confirm_delete_all'), function () {
	            window.localStorage.clear();

	            /*
	            * Maak nieuwe epSettings aan omdat gebruiker meteen hierna een
	            * pincode kan gaan instellen
	            */
	            storeJSON(getSettings());

	            /*
	            * Opnieuw initialiseren, nieuwe aanvaltypes aanmaken en de
	            * EP_MULTI_DAY cache opnieuw inlezen
	            */
	            initializeApplication(false);

	            phoneAlert(jQuery.i18n.prop('i18n_all_data_removed'));
	            return true;
	        });
	    });

	    /**
	    * Pinveld wijzigen afhandelen
	    */
	    $("#pin1text").on('click', function () {
	        clearPin();
	        pinChanged = true;
	    });

	    var saveSettings = function () {
	        var settings = getSettings();
	        settings.askPin = $("#askpinswitch").is(':checked');

	        if (pinChanged == true && isPinEnabled()) {
	            // Nieuwe pincode opslaan:
	            var pin1 = $("#pin1text").val();
	            var pin2 = $("#pin2text").val();
	            if (pin1 === pin2) {

	                /*-
	                * 
	                * Als de pin wijzigt moeten we de volgende dingen doen:
	                * 
	                * 1. Vervang de hashed pincode 
	                * 2. Genereer een nieuwe versleutel key
	                * 3. Opnieuw versleutelen van data met nieuwe key
	                * 4. Stel nieuwe versleutel key in
	                * 
	                */
	                // Step 1
	                settings.pincode = oneWayHash(pin1);

	                // Step 2
	                var newKey = generateKey();

	                // Step 3
	                var oldKey = window.sessionStorage.getItem('key');

	                // This situation could happen when the app was uninstalled,
	                // then try with the default key
	                if (oldKey == null)
	                    oldKey = DEFAULT_KEY;

	                reencodeData(oldKey, newKey);

	                // Step 4
	                settings.key = GibberishAES.enc(newKey, oneWayKey(pin1));
	                window.sessionStorage.setItem('key', newKey);
	            }
	            pinChanged = false;
	        } else if (!isPinEnabled()) {
	            settings.pincode = '';
	            settings.key = '';

	            // Reencode all data using the default key
	            reencodeData(window.sessionStorage.getItem('key'), DEFAULT_KEY);
	            window.sessionStorage.setItem('key', DEFAULT_KEY);
	        }

	        if (doReload == true) {
	            settings.language = $('#select-language').val();
	            console.log(settings.language);
	        }
	        settings.medicinelist = $('#select_medicine_list').val();
	        
			settings.useMyData = $("#gebruikGegevensVoorOnderzoek").is(':checked');
			settings.adminEmail = $("#berichtenVanBeheerder").is(':checked'); 
	        storeJSON(settings, settings.id);

	        if (doReload == true) {
	            // Terug naar de main pagina en dan meteen een reload aanroepen.
	            /*
	            * $.mobile.changePage("#calendarWeekPage", { reverse: true });
	            */
	        	phoneAlert(jQuery.i18n.prop('i18n_change_druglist'));
	            window.location = "application.html";
	        } else {
	            // Terug naar de settings pagina en dan meteen een reload
	            // aanroepen.
	            navigationController.gotoPage("#settingsPage");
	        }
	    };
	    var validateOK = function () {
	        var askPin = $("#askpinswitch").is(':checked');
	        var message = "";
	        if (askPin && pinChanged) {
	            var pin1 = $("#pin1text").val();
	            var pin2 = $("#pin2text").val();
	            if (pin1 !== pin2) {
	                message = jQuery.i18n.prop('i18n_settings_pin_not_match');
	                alert(message);
	                return false;
	            }
	            if (pin1 === "") {
	                message = jQuery.i18n.prop('i18n_settings_pin_not_entered');
	                alert(message);
	                return false;
	            }
	            // match aan 4 cijfers
	            var pinexpression = /^\d\d\d\d$/;
	            if (pin1.match(pinexpression) === null) {
	                message = jQuery.i18n.prop('i18n_settings_pin_not_4_number');
	                alert(message);
	                return false;
	            }
	        }
	        return true;
	    };

	    $("#select-language").bind('change', function () {
	        doReload = true;
	        var selectedLanguage = $("#select-language").val();
	        rebuildMedicineList(selectedLanguage);
	    });
	    $("#select_medicine_list").bind('change', function () {
	        doReload = true;
	    });

	    /**
	    * Toggle pin on/off afhandelen
	    */
	    $("#askpinswitch").bind('change', function () {
	        if (!isPinEnabled()) {
	            enablePinFields(false);
	            $("#pin1text").unbind('click');
	        } else {
	            $("#pin1text").on('click', function () {
	                clearPin();
	                pinChanged = true;
	            });
	            clearPin();
	            pinChanged = true;
	            enablePinFields(true);
	        }
	    });

	});

	$('#preferencesPage').live('pageshow', function() {
		// refresh de pagina
		var settings = getSettings();

		/*
		 * Settings inlezen en controls goedzetten
		 */
		if (settings != undefined) {
			// Taal goedzetten
			$('#select-language').val(settings.language);
			$('#select-language').selectmenu("refresh", true);

			var confPin = window.sessionStorage.getItem("configurePin");
			if (confPin != null && confPin == "yes") {
				window.sessionStorage.removeItem("configurePin");
				pinChanged = true;// force a real pin entry
			}

			var hasPin = settings.askPin || confPin === "yes";
			var useMyData = settings.useMyData || 0;
			var adminEmail = settings.adminEmail || 0;
			
			$("#askpinswitch").attr('checked', hasPin).checkboxradio("refresh");
			$("#gebruikGegevensVoorOnderzoek").attr('checked', useMyData).checkboxradio("refresh");
			$("#berichtenVanBeheerder").attr('checked', adminEmail).checkboxradio("refresh");

			enablePinFields(hasPin);

			rebuildMedicineList(settings.language);
			// select current medicine list
			var selected = settings.medicinelist;
			if (typeof selected === "undefined") {
				selected = "nl-NL";
			}
			$("#select_medicine_list option[value='" + selected + "']").attr('selected', 'selected');
			$("#select_medicine_list").selectmenu('refresh', true);
			
		}

	});

};
initializeSettings();

function generateKey() {
	var randomKey = "";
	for ( var i = 0; i < 80; i++) {
		var randomCharCode = (Math.random() * 82) + 40;

		// 92 is backslash which will lead to undesired escaping in the string.
		if (randomCharCode == 92)
			randomCharCode++;

		randomKey = randomKey + String.fromCharCode(randomCharCode);
	}
	return randomKey;
}

function enablePinFields(enabled) {
	if (enabled == true) {
		$("#pin1text").val("****");
		$("#pin2text").val("****");
		$("#pin1text").textinput('enable');
		$("#pin2text").textinput('enable');
	} else {
		$("#pin1text").textinput('disable');
		$("#pin2text").textinput('disable');
		$("#pin1text").val("");
		$("#pin2text").val("");
	}
}

function clearPin() {
	$("#pin1text").val('');
	$("#pin2text").val('');
}

function getSettings() {
	if(SETTINGS == undefined) {
		SETTINGS = getJSON('epSettings');
		if(SETTINGS == null) {
			SETTINGS = new epSettings();
			return SETTINGS;
		}
	}
	return SETTINGS[0];
}

function isPinEnabled() {
	return $('#askpinswitch').is(':checked');
}