var validator = {

	validateStarttimePreceedsEndTime : function(startTime, endTime) {
		if (startTime > endTime) {
			var message = $.i18n.prop('i18n_validation_error_starttime_endtime');
			phoneAlert(message);
			return false;
		}
		// ok
		return true;
	},

	validateStringIsWholeNumberGreaterThanZero : function(value, name) {
		var unitIsNumber = (value.match(/^\d+$/) !== null);
		var message = $.i18n.prop("i18n_validation_error_enter_a_number_for");
		if (typeof name !== "undefined") {
			message = message + ' ' + name;
		} else {
			message = message + ' ' + $.i18n.prop("i18n_validation_error_quantity");
		}

		if (!unitIsNumber) {
			phoneAlert(message);
			return false;
		} else {
			var theNumber = parseInt(value);
			// if you define a 0
			if (theNumber <= 0) {
				phoneAlert(message);
				return false;
			}
		}
		return true;
	},

	validateStringIsFloatNumberGreaterThanZero : function(value, name) {
		// use a '.' as decimal separator.
		var floatExpression = /^[-+]?[0-9]*\.?[0-9]+$/;
		var unitIsNumber = (value.match(floatExpression) !== null);
		var message = $.i18n.prop("i18n_validation_error_enter_a_number_for");
		if (typeof name !== "undefined") {
			message = message + ' ' + name;
		} else {
			message = message + ' ' + $.i18n.prop("i18n_validation_error_quantity");
		}

		if (!unitIsNumber) {
			phoneAlert(message);
			return false;
		} else {
			var theNumber = parseFloat(value);
			// if you define a 0
			if (theNumber <= 0) {
				phoneAlert(message);
				return false;
			}
		}

		return true;
	},

	validateIsPhoneNumber : function(value) {
		var message = $.i18n.prop("i18n_validation_error_phone_number");
		var stripped = value.replace(/[\s()+-\/\.\#]/gi, ""); // toegestane
		// tekens
		// strippen
		var digitOrDash = /^\d{3,15}$/; // 3 of meer nummers overhouden, max ter
		// bescherming
		var isPhoneNumber = (stripped.match(digitOrDash) !== null);
		if (!isPhoneNumber) {
			phoneAlert(message);
			return false;
		}
		return true;
	},

	validateIsEmail : function(value) {
		var message = $.i18n.prop("i18n_validation_error_email");
		var emailRegex = /^[A-Za-z0-9\._\%\-]+@[A-Za-z0-9\.\-]+\.[A-Za-z]{2,4}$/;
		var isEmail = (value.match(emailRegex) !== null);
		if (!isEmail) {
			phoneAlert(message);
			return false;
		}
		return true;
	},

	validateAtLeastOneCheckboxIsChecked : function(targetId) {

		var checkBoxes = $(targetId + ' input[type="checkbox"]');
		for ( var c in checkBoxes) {
			var cb = checkBoxes[c];
			if (cb.checked) {
				return true;
			}
		}

		phoneAlert(jQuery.i18n.prop('i18n_validation_error_no_checkbox_checked'));
		return false;
	},

	validatePassword : function(password) {
		if (password.length < 8) {
			var message = $.i18n.prop("i18n_validation_error_password");
			phoneAlert(message);
			return false;
		}
		return true;
	},

	validateUsername : function(username) {
		if (username.length < 3) {
			var message = $.i18n.prop("i18n_validation_error_username_tooshort");
			phoneAlert(message);
			return false;
		}
		return true;
	}
};
